<?php
require("config.php");

$span = $_GET[span];
$style = $_GET[style];
$debug = $_GET[debug];

if (file_exists($PATH_TO_RRDTOOL) && file_exists($PATH_TO_RRD_ARCHIVE)) {
	$graph  = "$PATH_TO_RRDTOOL graph - ";
	if ($span == "day") {
		$graph .= '--title="Recieved Messages (5 minute average)" ';
	} elseif ($span == "week") {
		$graph .= "--start=-604800 ";
		$graph .= '--title="Recieved Messages (30 minute average)" ';
	} elseif ($span == "month") {
		$graph .= "--start=-2678400 ";
		$graph .= '--title="Recieved Messages (2 hour average)" ';
	} elseif ($span == "year") {
		$graph .= "--start=-33053184 ";
		$graph .= '--title="Recieved Messages (1 day average)" ';
	}
	$graph .= '--imgformat=PNG ';
	$graph .= '--alt-autoscale-max ';
	$graph .= '--lower-limit=0 ';
	$graph .= "--width=$IMAGE_WIDTH ";
	$graph .= "--height=$IMAGE_HEIGHT ";
	$graph .= "DEF:clean=$PATH_TO_RRD_ARCHIVE:clean:AVERAGE ";
	$graph .= "DEF:rejected=$PATH_TO_RRD_ARCHIVE:rejected:AVERAGE ";
	$graph .= "DEF:tossed=$PATH_TO_RRD_ARCHIVE:tossed:AVERAGE ";
	$graph .= "DEF:tg=$PATH_TO_RRD_ARCHIVE:teergrubed:AVERAGE ";
	$graph .= "DEF:tgmax=$PATH_TO_RRD_ARCHIVE:teergrubed_max:AVERAGE ";
	$graph .= "DEF:accepted=$PATH_TO_RRD_ARCHIVE:accepted:AVERAGE ";
	$graph .= "DEF:unrouteable=$PATH_TO_RRD_ARCHIVE:unrouteable:AVERAGE ";
	$graph .= "DEF:unrouteable_spam=$PATH_TO_RRD_ARCHIVE:unrouteable_spam:AVERAGE ";
	$graph .= "DEF:temprejected=$PATH_TO_RRD_ARCHIVE:temprejected:AVERAGE ";
	if ($style == "simple") {
		$graph .= 'CDEF:nospam_count=clean,unrouteable,+ ';
		if ($COUNT_TEMPREJECTED_AND_TGMAX) {
			$graph .= 'CDEF:spam_count=rejected,tossed,+,tg,+,tgmax,+,accepted,+,unrouteable_spam,+,temprejected,+ ';
		} else {
			$graph .= 'CDEF:spam_count=rejected,tossed,+,tg,+,accepted,+,unrouteable_spam,+ ';
		}
		if ($SHOW_PER_5_MINUTES) {
			$graph .= '--vertical-label="Messages / 5 minutes" ';
			$graph .= 'CDEF:cmail=nospam_count,300,* ';
			$graph .= 'CDEF:spam=spam_count,300,* ';
		} else {
			$graph .= '--vertical-label="Messages / second" ';
			$graph .= 'CDEF:cmail=nospam_count,1,* ';
			$graph .= 'CDEF:spam=spam_count,1,* ';
		}
		$graph .= 'AREA:cmail#00b000:"Normal" ';
		$graph .= 'GPRINT:cmail:LAST:"current\: %8.2lf" ';
		$graph .= 'GPRINT:cmail:AVERAGE:"average\: %8.2lf" ';
		$graph .= 'GPRINT:cmail:MAX:"maximum\: %8.2lf\n" ';
		$graph .= 'STACK:spam#FF4105:"Spam  " ';
		$graph .= 'GPRINT:spam:LAST:"current\: %8.2lf" ';
		$graph .= 'GPRINT:spam:AVERAGE:"average\: %8.2lf" ';
		$graph .= 'GPRINT:spam:MAX:"maximum\: %8.2lf\n" ';
	} elseif ($style == "detailed") {
		if ($SHOW_PER_5_MINUTES) {
			$graph .= '--vertical-label="Messages / 5 minutes" ';
			$graph .= "CDEF:cmail=clean,300,* ";
			$graph .= "CDEF:rejmail=rejected,300,* ";
			$graph .= "CDEF:tosmail=tossed,300,* ";
			$graph .= "CDEF:tgmail=tg,300,* ";
			$graph .= "CDEF:tgmmail=tgmax,300,* ";
			$graph .= "CDEF:accmail=accepted,300,* ";
			$graph .= "CDEF:urmail=unrouteable,300,* ";
			$graph .= "CDEF:ursmail=unrouteable_spam,300,* ";
			$graph .= "CDEF:tmprejmail=temprejected,300,* ";
		} else {
			$graph .= '--vertical-label="Messages / second" ';
			$graph .= "CDEF:cmail=clean,1,* ";
			$graph .= "CDEF:rejmail=rejected,1,* ";
			$graph .= "CDEF:tosmail=tossed,1,* ";
			$graph .= "CDEF:tgmail=tg,1,* ";
			$graph .= "CDEF:tgmmail=tgmax,1,* ";
			$graph .= "CDEF:accmail=accepted,1,* ";
			$graph .= "CDEF:urmail=unrouteable,1,* ";
			$graph .= "CDEF:ursmail=unrouteable_spam,1,* ";
			$graph .= "CDEF:tmprejmail=temprejected,1,* ";
		}
		
		$graph .= 'AREA:cmail#00b000:"Clean           " ';
		$graph .= 'GPRINT:cmail:LAST:"current\: %8.2lf" ';
		$graph .= 'GPRINT:cmail:AVERAGE:"average\: %8.2lf" ';
		$graph .= 'GPRINT:cmail:MAX:"maximum\: %8.2lf" ';
		$graph .= 'STACK:rejmail#FF4105:"Rejected        " ';
		$graph .= 'GPRINT:rejmail:LAST:"current\: %8.2lf" ';
		$graph .= 'GPRINT:rejmail:AVERAGE:"average\: %8.2lf" ';
		$graph .= 'GPRINT:rejmail:MAX:"maximum\: %8.2lf\n" ';
		$graph .= 'STACK:tosmail#B90054:"Tossed          " ';
		$graph .= 'GPRINT:tosmail:LAST:"current\: %8.2lf" ';
		$graph .= 'GPRINT:tosmail:AVERAGE:"average\: %8.2lf" ';
		$graph .= 'GPRINT:tosmail:MAX:"maximum\: %8.2lf" ';
		$graph .= 'STACK:tgmail#FF897C:"Teergrubed      " ';
		$graph .= 'GPRINT:tgmail:LAST:"current\: %8.2lf" ';
		$graph .= 'GPRINT:tgmail:AVERAGE:"average\: %8.2lf" ';
		$graph .= 'GPRINT:tgmail:MAX:"maximum\: %8.2lf\n" ';
		$graph .= 'STACK:tgmmail#862F2F:"Teergrubed max  " ';
		$graph .= 'GPRINT:tgmmail:LAST:"current\: %8.2lf" ';
		$graph .= 'GPRINT:tgmmail:AVERAGE:"average\: %8.2lf" ';
		$graph .= 'GPRINT:tgmmail:MAX:"maximum\: %8.2lf" ';
		$graph .= 'STACK:accmail#55D6D3:"accepted        " ';
		$graph .= 'GPRINT:accmail:LAST:"current\: %8.2lf" ';
		$graph .= 'GPRINT:accmail:AVERAGE:"average\: %8.2lf" ';
		$graph .= 'GPRINT:accmail:MAX:"maximum\: %8.2lf\n" ';
		$graph .= 'STACK:urmail#00694A:"Unrouteable     " ';
		$graph .= 'GPRINT:urmail:LAST:"current\: %8.2lf" ';
		$graph .= 'GPRINT:urmail:AVERAGE:"average\: %8.2lf" ';
		$graph .= 'GPRINT:urmail:MAX:"maximum\: %8.2lf" ';
		$graph .= 'STACK:ursmail#4444FF:"Unrouteable spam" ';
		$graph .= 'GPRINT:ursmail:LAST:"current\: %8.2lf" ';
		$graph .= 'GPRINT:ursmail:AVERAGE:"average\: %8.2lf" ';
		$graph .= 'GPRINT:ursmail:MAX:"maximum\: %8.2lf\n" ';
		$graph .= 'STACK:tmprejmail#8F005C:"Temprejected    " ';
		$graph .= 'GPRINT:tmprejmail:LAST:"current\: %8.2lf" ';
		$graph .= 'GPRINT:tmprejmail:AVERAGE:"average\: %8.2lf" ';
		$graph .= 'GPRINT:tmprejmail:MAX:"maximum\: %8.2lf" ';
	}
	if ($debug) {
		echo $graph;
	} else {
		header("Content-type: image/png");
		header("Pragma: no-cache");
		header("Cache-Control: no-cache, must-revalidate");
		$fp = popen($graph, "r");
		echo fpassthru($fp);
		pclose($fp);
	}
} else {
	echo "Check path's\n";
}

?>
